> ## Documentation Index
> Fetch the complete documentation index at: https://docs.emergence.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Bulk upsert FK edges

> Create or update FK edges for a resource. Existing edges are updated, new edges are created.



## OpenAPI

````yaml /openapi/em-runtime-utils-v2.yaml put /utils/{resource_type}/{resource_uri}/fk-edges
openapi: 3.1.0
info:
  title: em_runtime_utils
  version: 5.27.0
servers: []
security: []
paths:
  /utils/{resource_type}/{resource_uri}/fk-edges:
    put:
      tags:
        - fk-graph
      summary: Bulk upsert FK edges
      description: >-
        Create or update FK edges for a resource. Existing edges are updated,
        new edges are created.
      operationId: bulk_upsert_fk_edges
      parameters:
        - name: resource_type
          in: path
          required: true
          schema:
            type: string
            title: Resource Type
        - name: resource_uri
          in: path
          required: true
          schema:
            type: string
            title: Resource Uri
        - name: X-Project-ID
          in: header
          required: true
          schema:
            type: string
            title: X-Project-Id
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/FkEdgeBulkCreateRequest'
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/FkEdgeBulkCreateResponse'
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Bad Request
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
      security:
        - HTTPBearer: []
components:
  schemas:
    FkEdgeBulkCreateRequest:
      properties:
        edges:
          items:
            $ref: '#/components/schemas/FkEdgeCreateRequest'
          type: array
          maxItems: 1000
          minItems: 1
          title: Edges
          description: FK edges to upsert (max 1000)
      type: object
      required:
        - edges
      title: FkEdgeBulkCreateRequest
      description: Request to bulk upsert FK edges.
    FkEdgeBulkCreateResponse:
      properties:
        total:
          type: integer
          title: Total
          description: Total edges upserted
      type: object
      required:
        - total
      title: FkEdgeBulkCreateResponse
      description: Response for bulk FK edge upsert.
    ErrorResponse:
      properties:
        error:
          $ref: '#/components/schemas/ErrorBody'
      type: object
      required:
        - error
      title: ErrorResponse
      description: Standard error response model.
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    FkEdgeCreateRequest:
      properties:
        from_table_fqn:
          type: string
          maxLength: 1024
          title: From Table Fqn
          description: Source table FQN
        from_column:
          type: string
          maxLength: 255
          title: From Column
          description: Source column name
        to_table_fqn:
          type: string
          maxLength: 1024
          title: To Table Fqn
          description: Target table FQN
        to_column:
          type: string
          maxLength: 255
          title: To Column
          description: Target column name
      type: object
      required:
        - from_table_fqn
        - from_column
        - to_table_fqn
        - to_column
      title: FkEdgeCreateRequest
      description: Request to create a single FK edge.
    ErrorBody:
      properties:
        code:
          $ref: '#/components/schemas/ErrorCode'
        message:
          type: string
          title: Message
        details:
          additionalProperties: true
          type: object
          title: Details
        request_id:
          type: string
          title: Request Id
        timestamp:
          type: string
          format: date-time
          title: Timestamp
      type: object
      required:
        - code
        - message
        - request_id
        - timestamp
      title: ErrorBody
      description: Error body with structured details.
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    ErrorCode:
      type: string
      enum:
        - INVALID_REQUEST
        - INVALID_TOKEN
        - INSUFFICIENT_PERMISSIONS
        - RESOURCE_NOT_FOUND
        - RESOURCE_ALREADY_EXISTS
        - VALIDATION_ERROR
        - RATE_LIMIT_EXCEEDED
        - SERVICE_UNAVAILABLE
        - INTERNAL_ERROR
      title: ErrorCode
      description: Standard error codes for API responses.
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````